# Disclaimer

The following applies to all activities including, but not limited to, filing GitHub Issues, posting on GitHub Discussions, and creating GitHub PRs on this project.

## Premises

* This is a free opensource project.
  * We are very glad that you find this project useful, and we intend to make software that helps you.
  * But we are not obligated to work for you, make changes for you, or otherwise heed to your needs.

## Rules

These are the rules that you should follow when you participate in this project:

### Rule 1: Please be nice

You don't have to thank us, but we do not owe you one bit of code or a fix, even if it's a critical one.

We write software because we're curious, we fix bugs because we have integrity. But we do not owe you anything. Please do not order us to work for you.

### Rule 2: Please provide code for technical issues.

The authors of this project do NOT know what you are trying to accomplish.

In order to understand what you are trying to accomplish, we need you to explain your intentions, but we also need code.

Except for those cases when you absolutely cannot do so, please ALWAYS include a standalone Go test function that shows us exactly how the code fails and what your expectations are. 

Failing to attach a test code may result in the authors not taking up to review your report.

We enjoy solving problems, but we are not your support staff (see Rule 1). We do not want work hard to pry information out of you.

Please help us help you by providing us with a reproducible code.

### Rule 3: Please use correct medium.

If you found a bug, a problem with the API design, or other technical issues, please file a GitHub Issue or a PR (but see previous rules).

You may also use GitHub Issues if they are about actionable items.

For everything else, e.g. open-ended discussions, questions, concerns, or commentaries, please use GitHub Discussions. Please do not use GitHub Issues or PR for these, as the maintainers would like to keep Issues/PRs as clean as possible with minimal long-running tasks.

### Rule 4: Delete the relevant Disclaimer section on Issues/PRs

If you came here from an issue/PR template, please make sure to delete the section on "Disclaimers" from the template.
Failure to do so may result in the maintainers assuming that you have not fully read the disclaimers


